package main

import "sync/atomic"

type expdata struct {
	ReadError          int64
	UnmarshalError     int64
	DecodeBacklogCount int64
	DecodeBacklogNow   int64
	DialError          int64
	WriteError         int64

	Events int64
}

func (ed *expdata) dup() *expdata {
	var out expdata

	out.ReadError = atomic.LoadInt64(&ed.ReadError)
	out.UnmarshalError = atomic.LoadInt64(&ed.UnmarshalError)
	out.DecodeBacklogCount = atomic.LoadInt64(&ed.DecodeBacklogCount)
	out.DecodeBacklogNow = atomic.LoadInt64(&ed.DecodeBacklogNow)
	out.DialError = atomic.LoadInt64(&ed.DialError)
	out.WriteError = atomic.LoadInt64(&ed.WriteError)

	out.Events = atomic.LoadInt64(&ed.Events)

	return &out
}
